<!DOCTYPE html>
<html lang="es">
<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Capitulo_3</title>
</head>
<body>
    <h1>Capitulo 4</h1>
    <a>Ejercicio 5</a>

    <script>


        class Node {
            constructor(val) {
                this.data = val;
                this.left = null;
                this.right = null; 
            }
            
            validarBST() {
                return root.bstUtil(root, Number.MIN_VALUE, Number.MAX_VALUE);
            }

            bstUtil(node, min, max) {
                if (node === null) {
                    return true;
                }

                if (node.data < min || node.data > max) {
                    return false;
                }

                return (root.bstUtil(node.left, min, node.data-1)) && 
                        root.bstUtil(node.right, node.data+1, max);
            }
        }

        let root;
        root = new Node(4);
        root.left = new Node(2);
        root.right = new Node(5);
        root.left.left = new Node(1);
        root.left.right = new Node(3);

        if (root.validarBST()) {
            console.log("El Arbol Binario 'SI' es BST");
        } else {
            console.log("El Arbol Binario 'NO' es BST");
        }
        
    </script>
    
</body>
</html>